unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, StdCtrls;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    premier1: TMenuItem;
    deuxime1: TMenuItem;
    bientot1: TMenuItem;
    aide1: TMenuItem;
    tic1: TMenuItem;
    tac1: TMenuItem;
    nul1: TMenuItem;
    suite1: TMenuItem;
    Memo1: TMemo;
    Memo2: TMemo;
    dsactiv1: TMenuItem;
    N1: TMenuItem;
    atchoum1: TMenuItem;
    zig1: TMenuItem;
    zag1: TMenuItem;
    bonjour1: TMenuItem;
    salut1: TMenuItem;
    machin1: TMenuItem;
    N2: TMenuItem;
    Button1: TButton;
    Button2: TButton;
    juste1: TMenuItem;
    PopupMenu1: TPopupMenu;
    Demain1: TMenuItem;
    Plus1: TMenuItem;
    N2chiffres1: TMenuItem;
    N4chiffres1: TMenuItem;
    isin1: TMenuItem;
    sicovam1: TMenuItem;
    procedure suite1Click(Sender: TObject);
    procedure deuxime1Click(Sender: TObject);
    procedure premier1AdvancedDrawItem(Sender: TObject; ACanvas: TCanvas;
                                       ARect: TRect; State: TOwnerDrawState);
    procedure tic1Click(Sender: TObject);
    procedure tac1Click(Sender: TObject);
    procedure premier1MeasureItem(Sender: TObject; ACanvas: TCanvas;
                                  var Width, Height: Integer);
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure premier1Click(Sender: TObject);
    procedure N2chiffres1Click(Sender: TObject);
    procedure N4chiffres1Click(Sender: TObject);
    procedure nul1Click(Sender: TObject);
  private
    { Dclarations prives }

  public
    { Dclarations publiques }


  end;

const
  Color_No_Select      : TColor = 16762052;  // Couleur de fond de l'item survol.
  Color_Select         : TColor = 16748945;  // Couleur de fond de l'item slectionn.
  Color_Desactive      : TColor = clWhite;   // Couleur de fond de l'item dsactiv.
  Color_Frame          : TColor = clBlue ;   // Couleur des frames droit et bas de l'item.
  Color_Frame_bis      : TColor = 16761992;  // Couleur des frames haut et gauche de l'item.
  Color_Ligne_Select   : TColor = clWhite;   // Couleur des caractres de l'item activ.
  Color_Ligne_Desactive: TColor = clGray;    // Couleur des caractres de l'item dsactiv.
  Epaisseur_Frame      : Integer = 3;        // Epaisseur de la frame.
  Hauteur_Fond         : Integer = 8;        // Hauteur supplmentaire des items.

// Metre les proprits "OwnerDraw" des "TMainMenu" et "TPopuMenu"  TRUE.

// Pour crire en gras : crire quelque chose dans le hint de l'item choisi,
//   ... mme un simple espace.

var
  Form1    : TForm1;
  SousMenu :Boolean;    // Ne pas oublier de mettre cette variable  False ds que
                        //    le menu a t retrac et que l'on en est sorti.
  clic_essai: boolean;  // pour tester
  clic_boum : boolean;  // pour tester
implementation

{$R *.DFM}

// Affichage du contour des boutons d'icone.
procedure Affiche_Plot(Line_Menu: TMenuItem; Image: String; ACanvas: TCanvas; ARect: TRect);
var
  Bitmap:TBitmap;
begin
  If not Line_Menu.Bitmap.Empty  then
    begin
      Bitmap:= TBitmap.Create;
      with Bitmap do
        try
          LoadFromResourceName(hinstance, Image); //  si bitmap rcupr dans les ressources...
       //------   LoadFromFile(Image);            //  si bitmap rcupr dans le dossier...
          Transparent := True;
          TransParentColor := Canvas.pixels[0, 0];
          TransparentMode := tmAuto;
          ACanvas.Draw(ARect.Left - 1, ARect.Top + 1, Bitmap);
        finally
          Free;
        end;
    end;
end;

// Affichage du contour de la case avec la coche ou sans la coche.
procedure Affiche_Coche(Line_Menu: TMenuItem; Image: String; ACanvas: TCanvas; ARect: TRect);
var
  Bitmap: TBitmap;
  h     : Integer;
begin
  h := (ARect.Bottom - ARect.Top - 20) div 2 + 1;
  Bitmap:= TBitmap.Create;
  with Bitmap do
    try
      LoadFromResourceName(hinstance, Image); //  si bitmap rcupr dans les ressources...
    //------  LoadFromFile(Image);            //  si bitmap rcupr dans le dossier...
      Transparent := True;
      TransParentColor := Canvas.pixels[0, 0];
      TransparentMode := tmAuto;
      ACanvas.Draw(ARect.Left + 1, ARect.Top + 1 + h , Bitmap);
    finally
      Free;
    end;
end;

// Affichage soit du trait de sparation
//          ou bien de l'icone du bouton.
procedure Bitmap_Canvas(Line_Menu: TMenuItem; Carre: TRect; Page: TCanvas);
var
  Place: TRect;
begin
// Calcul de l'espace du dessin.
  If Line_Menu.Caption = '-' // ou bien Line_Menu.IsLine
    then Place := Rect(Carre.Left, Carre.Top , Carre.Right, Carre.Top + 2)
    else Place := Rect(Carre.Left + 1, Carre.Top + 1
                       , Carre.Left + 17, Carre.Top + 18);
  Page.StretchDraw(Place, Line_Menu.Bitmap);  // Affichage.
end;

procedure TForm1.premier1AdvancedDrawItem(Sender: TObject; ACanvas: TCanvas;
                                          ARect: TRect; State: TOwnerDrawState);
var
  Fond     : TRect;
//  Fond_bis : TRect;  // si les frames ne sont pas biaises.
  Support  : TRect;
  Efface   : TRect;
  Decalage : TRect;
  Ligne    : String;
  Line_Menu: TMenuItem;
  Fond_bis : array [1..5] of TPoint; // si les frames sont biaises (+ sympa).
begin
  Line_Menu := (sender as TMenuItem); // Identifie l'item.
  If Line_Menu.Count > 0 then SousMenu := True; // Y a-t-il un sous-menu ?
  Ligne := Line_Menu.Caption; // Le texte de l'item.

// Dimensions du canvas de l'item
  Fond := ARect;
  If not Line_Menu.Bitmap.Empty or (Line_Menu.Tag = -1)
    then Fond.Left := ARect.Left + 20; // avec icone ou case de la coche.

// Dimensions du canvas pour les frames haute et gauche non biaises..
{
  Fond_bis.Left := Fond.Left;
  Fond_bis.Top := Fond.Top;
  Fond_bis.Right := ARect.Right - Epaisseur_Frame;
  Fond_bis.Bottom := ARect.Bottom - Epaisseur_Frame;
}

// Dimensions du canvas pour les frames haute et gauche biaises..
  Fond_bis[1].x := Fond.Left;
  Fond_bis[1].y := ARect.Top;
  Fond_bis[2].x := Fond.Right - 1;
  Fond_bis[2].y := ARect.Top;
  Fond_bis[5].x := Fond.Left;
  Fond_bis[5].y := ARect.Bottom - 1;
  Fond_bis[3].x := Fond_bis[2].x - Epaisseur_Frame;
  Fond_bis[3].y := Fond_bis[2].y + Epaisseur_Frame;
  Fond_bis[4].x := Fond_bis[5].x + Epaisseur_Frame;
  Fond_bis[4].y := Fond_bis[5].y - Epaisseur_Frame;

// Dimension du canvas pour le texte.
  Support.Left := Fond.Left + Epaisseur_Frame;
  Support.Top := ARect.Top + Epaisseur_Frame ;
  Support.Right := ARect.Right - Epaisseur_Frame;
  Support.Bottom := ARect.Bottom - Epaisseur_Frame;

  If (odDisabled in State) // Si dsactiv...
    then
      begin
        ACanvas.Font.Color := Color_Ligne_Desactive;  // Sa couleur.
        ACanvas.Brush.Color := Color_Desactive;  // la couleur du texte.
        Decalage := ARect;
        Decalage.Bottom:= ARect.Bottom - 1;  // dcalage du canvas
        ACanvas.FillRect(Decalage);  // trac puis criture du texte centr.
        DrawText(ACanvas.Handle, PChar(Ligne), -1, Support, DT_SINGLELINE or DT_CENTER or DT_VCENTER);
      end
    else
      begin  // si focus ou slection...
        If (odFocused in State) or (odSelected in State) then
            begin
           // Trac frame du fond (frames droit et bas).
              ACanvas.Brush.Color := Color_Frame;
              ACanvas.FillRect(Fond);
           // Trac des frames haut et gauche.
           // ACanvas.FillRect(Fond_bis); // si les frames ne sont pas biaises.

           // Si les frames sont biaises.
              ACanvas.Pen.Color := Color_Frame_bis;
              ACanvas.Brush.Color := Color_Frame_bis;
              ACanvas.Polygon([Fond_bis[1], Fond_bis[2], Fond_bis[3],
                               Fond_bis[4], Fond_bis[5]]);

           // Trac du fond d'criture.
              ACanvas.Brush.Color := Color_Select;
              ACanvas.FillRect(Support);
           // Si rien n'est crit dans la proprit "Hint" du "TMenuItem"
              If Line_Menu.Hint = '' then ACanvas.Font.Style := [] // Ecriture normale
                                  // Sinon criture en gras.
                                     else ACanvas.Font.Style := [fsBold];
              ACanvas.Font.Color := Color_Ligne_Select; // Couleur de l'criture.
           // Si pas de case de coche vide prvue ...
           // Mettre la proprit "Tag" du "TMenuItem"  -1 pour faire apparaitre
           //   systmatiquement la case de coche vide ou coche.
           // ... et si l'item n'est pas coch
              If (Line_Menu.Tag <> -1) and not Line_Menu.Checked then
                begin
              //  Dimensions du canvas pour effacer l'icone inactive afin d'afficher dcal
              //       celle qui sera active.  --> 3D.
                  Efface := ARect;
                  Efface.Right := Fond.Left;
                  ACanvas.Brush.Color := Color_No_Select; // Couleur d'effacement.
                  ACanvas.FillRect(Efface); // Effacer.
              //  Trac bouton enfonc.
                  Affiche_Plot(Line_Menu,'Plot_Creux', ACanvas, Efface); // bitmap dans ressources.
         //-----  Affiche_Plot(Line_Menu,'Plot_Creux.bmp', ACanvas, Efface); // bitmap dans dossier
              //  Dimensions du canvas pour afficher l'icone dcale.
                  Efface.Left := Efface.Left + 1;
                  Efface.Right := Efface.Right + 1;
                  Efface.Top := Efface.Top + 1;
                  Efface.Bottom := Efface.Bottom + 1;
                  Bitmap_Canvas(Line_Menu, Efface, ACanvas); // Affichage de l'icone.
                  ACanvas.Brush.Color := Color_Select; // Mettre en couleur active.
                end
            end
          else  // sinon...
            begin
              ACanvas.Brush.Color := Color_No_Select;
              ACanvas.FillRect(aRect);
              If (Line_Menu.Tag <> -1) and not Line_Menu.Checked then
                begin
              //  Trac bouton relev.
                  Affiche_Plot(Line_Menu,'Plot_Plein', ACanvas, ARect); // bitmap dans ressources.
         //-----  Affiche_Plot(Line_Menu,'Plot_Plein.bmp', ACanvas, ARect); // bitmap dans dossier.
                  Bitmap_Canvas(Line_Menu, ARect, ACanvas); // Affichage de l'icone.
                end;
            end
      end;

// Si non dsactiv et coch ...l'afficher.
  If not (odDisabled in State) then If Line_Menu.Checked
    then Affiche_Coche(Line_Menu,'Coche_Pleine_Red', ACanvas, ARect)
//-----  Affiche_Coche(Line_Menu,'Coche_Pleine_Red.bmp', ACanvas, ARect)
  // Si non dsactiv et case  cocher prvue ...l'afficher.
    else If Line_Menu.Tag = -1 then Affiche_Coche(Line_Menu, 'Coche_Vide', ACanvas, ARect); // bitmap dans ressources.
                            //----- Affiche_Coche(Line_Menu, 'Coche_Vide.bmp', ACanvas, ARect); // bitmap dans dossier.
 { }
// Si il y a un sous-menu ou si l' criture est en caratre gras... aligner  gauche,
  If SousMenu and (ACanvas.Font.Style <> [])
    then DrawText(ACanvas.Handle,  PChar(' ' + Ligne), -1, Support, DT_SINGLELINE or  DT_LEFT or DT_VCENTER)
 // ...sinon centrer.
    else DrawText(ACanvas.Handle, PChar(Ligne), -1, Support, DT_SINGLELINE or  DT_CENTER or DT_VCENTER);
       
// Si c'est une ligne  tracer.
  If Line_Menu.IsLine  then  // ou If Line_Menu.Caption = '-' then
    begin
      ACanvas.Brush.Color := Color_No_Select;
      ACanvas.FillRect(ARect);
      Bitmap_Canvas(Line_Menu, ARect, ACanvas);
    end;
end;

procedure TForm1.premier1MeasureItem(Sender: TObject; ACanvas: TCanvas;
                                     var Width, Height: Integer);
begin
// Largeur des items.
  Width := ACanvas.TextExtent((sender as TMenuItem).Caption).cx;
  Width := Width * 148  div 100;
  If SousMenu then Width := Width + 20;  // Tenir compte du bullet.
// Hauteur des items...
  If (sender as TMenuItem).IsLine
    then Height := 2  // ... si c'est une ligne.
    else Height := Height + Hauteur_Fond; // ... si c'est une icone.     
end;

procedure TForm1.FormCreate(Sender: TObject);

begin
clic_essai:= true;
clic_boum := true;
end;

procedure TForm1.tic1Click(Sender: TObject);
begin
   memo1.Visible:= true;
   memo2.Visible:= true;
end;

procedure TForm1.tac1Click(Sender: TObject);
begin
   memo1.Visible:= false;
   memo2.Visible:= false;
   If tac1.Checked then tac1.checked := false
   else tac1.checked := true;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  I: Integer;
begin
  If clic_essai
    then
      begin
        for I := 0 to bientot1.Count-1 do bientot1.Items[I].Enabled := False;
        clic_essai := false;
      end
    else
      begin
        for I := 0 to bientot1.Count-1 do bientot1.Items[I].Enabled := true;
        clic_essai := true;
      end
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  FirstItem :TMenuItem;
begin
  FirstItem := MainMenu1.Items[2];
  If clic_boum
    then
      begin
        FirstItem.Enabled := false;
        clic_boum := false;
      end
    else
      begin
        FirstItem.Enabled := true;
        clic_boum := true;
      end;

If zig1.Checked then zig1.Checked := false
                else zig1.Checked := true;

end;

procedure TForm1.premier1Click(Sender: TObject);
begin
  SousMenu := False;
end;

procedure TForm1.suite1Click(Sender: TObject);
begin
   memo1.Visible:= true;
   memo2.Visible:= false;
end;

procedure TForm1.deuxime1Click(Sender: TObject);
begin
   memo2.Visible:= true;
   memo1.Visible:= false;
end;


procedure TForm1.N2chiffres1Click(Sender: TObject);
begin
  If not N2chiffres1.Checked then
    begin
      N2chiffres1.Checked := True;
      N4chiffres1.Checked := False;
    end
end;

procedure TForm1.N4chiffres1Click(Sender: TObject);
begin
  If not N4chiffres1.Checked then
    begin
      N4chiffres1.Checked := True;
      N2chiffres1.Checked := False;
    end

end;

procedure TForm1.nul1Click(Sender: TObject);
begin
  MessageDlg('fabien.duforest@free.fr' + #10#13 +
              FormatDateTime(('dddd d mmmm yyyy'), (now)),
              mtWarning, [mbYes] + [mbNo], 0);
end;

end.



